/* server.c generated by valac 0.20.1.30-1b1d, the Vala compiler
 * generated from server.vala, do not modify */

/*
 * Copyright (C) 2012-2013 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2012-2013 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <json-glib/json-glib.h>
#include <libkkc/libkkc.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <stdio.h>
#include <config.h>


#define TYPE_SERVER_ERROR_CODE (server_error_code_get_type ())

#define TYPE_SERVER_ERROR (server_error_get_type ())
typedef struct _ServerError ServerError;
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))

#define TYPE_SERVER_RESPONSE (server_response_get_type ())
typedef struct _ServerResponse ServerResponse;
#define _server_error_free0(var) ((var == NULL) ? NULL : (var = (server_error_free (var), NULL)))

#define TYPE_COMMAND_HANDLER (command_handler_get_type ())
#define COMMAND_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMAND_HANDLER, CommandHandler))
#define COMMAND_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMMAND_HANDLER, CommandHandlerClass))
#define IS_COMMAND_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMAND_HANDLER))
#define IS_COMMAND_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMMAND_HANDLER))
#define COMMAND_HANDLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMMAND_HANDLER, CommandHandlerClass))

typedef struct _CommandHandler CommandHandler;
typedef struct _CommandHandlerClass CommandHandlerClass;
typedef struct _CommandHandlerPrivate CommandHandlerPrivate;

#define TYPE_REPL (repl_get_type ())
#define REPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_REPL, Repl))
#define IS_REPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_REPL))
#define REPL_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_REPL, ReplIface))

typedef struct _Repl Repl;
typedef struct _ReplIface ReplIface;

#define TYPE_SERVER_REPL (server_repl_get_type ())
#define SERVER_REPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SERVER_REPL, ServerRepl))
#define SERVER_REPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SERVER_REPL, ServerReplClass))
#define IS_SERVER_REPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SERVER_REPL))
#define IS_SERVER_REPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SERVER_REPL))
#define SERVER_REPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SERVER_REPL, ServerReplClass))

typedef struct _ServerRepl ServerRepl;
typedef struct _ServerReplClass ServerReplClass;
typedef struct _ServerReplPrivate ServerReplPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define __vala_JsonObject_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonObject_free (var), NULL)))
#define __vala_JsonArray_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonArray_free (var), NULL)))

typedef enum  {
	SERVER_ERROR_CODE_PARSE_ERROR = -32700,
	SERVER_ERROR_CODE_INVALID_REQUEST = -32600,
	SERVER_ERROR_CODE_METHOD_NOT_FOUND = -32601,
	SERVER_ERROR_CODE_INVALID_PARAMS = -32602,
	SERVER_ERROR_CODE_INTERNAL_ERROR = -32603
} ServerErrorCode;

struct _ServerError {
	ServerErrorCode code;
	gchar* message;
	JsonNode* data;
};

struct _ServerResponse {
	JsonNode* result;
	ServerError* error;
};

typedef void (*CommandCallback) (JsonNode* params, ServerResponse* result, void* user_data);
struct _CommandHandler {
	GObject parent_instance;
	CommandHandlerPrivate * priv;
};

struct _CommandHandlerClass {
	GObjectClass parent_class;
};

struct _CommandHandlerPrivate {
	CommandCallback cb;
	gpointer cb_target;
};

struct _ReplIface {
	GTypeInterface parent_iface;
	gboolean (*parse_arguments) (Repl* self, gchar** args, int args_length1, GError** error);
	gboolean (*run) (Repl* self, GError** error);
};

struct _ServerRepl {
	GObject parent_instance;
	ServerReplPrivate * priv;
};

struct _ServerReplClass {
	GObjectClass parent_class;
};

struct _ServerReplPrivate {
	KkcContext* context;
	GeeMap* command_handlers;
};


static gpointer command_handler_parent_class = NULL;
static gpointer server_repl_parent_class = NULL;
extern gchar* opt_system_dictionary;
extern gchar* opt_user_dictionary;
extern gchar* opt_typing_rule;
extern GOptionGroup* model_group;
extern gchar* opt_model;
static ReplIface* server_repl_repl_parent_iface = NULL;

GType server_error_code_get_type (void) G_GNUC_CONST;
GType server_error_get_type (void) G_GNUC_CONST;
ServerError* server_error_dup (const ServerError* self);
void server_error_free (ServerError* self);
void server_error_copy (const ServerError* self, ServerError* dest);
void server_error_destroy (ServerError* self);
static void _vala_JsonNode_free (JsonNode* self);
void server_error_append (ServerError *self, JsonBuilder* builder);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
GType server_response_get_type (void) G_GNUC_CONST;
ServerResponse* server_response_dup (const ServerResponse* self);
void server_response_free (ServerResponse* self);
void server_response_copy (const ServerResponse* self, ServerResponse* dest);
void server_response_destroy (ServerResponse* self);
void server_response_append (ServerResponse *self, JsonBuilder* builder, JsonNode* id);
GType command_handler_get_type (void) G_GNUC_CONST;
#define COMMAND_HANDLER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_COMMAND_HANDLER, CommandHandlerPrivate))
enum  {
	COMMAND_HANDLER_DUMMY_PROPERTY
};
CommandHandler* command_handler_new (CommandCallback cb, void* cb_target);
CommandHandler* command_handler_construct (GType object_type, CommandCallback cb, void* cb_target);
void command_handler_call (CommandHandler* self, JsonNode* params, ServerResponse* result);
static void command_handler_finalize (GObject* obj);
GType repl_get_type (void) G_GNUC_CONST;
GType server_repl_get_type (void) G_GNUC_CONST;
#define SERVER_REPL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SERVER_REPL, ServerReplPrivate))
enum  {
	SERVER_REPL_DUMMY_PROPERTY
};
static gboolean server_repl_real_parse_arguments (Repl* base, gchar** args, int args_length1, GError** error);
static gboolean server_repl_real_run (Repl* base, GError** error);
static void server_repl_create_error_response (ServerRepl* self, ServerErrorCode code, const gchar* message, JsonNode* data, ServerResponse* result);
static JsonObject* _vala_JsonObject_copy (JsonObject* self);
static void _vala_JsonObject_free (JsonObject* self);
static void server_repl_do_process_key_events (ServerRepl* self, JsonNode* params, ServerResponse* result);
static JsonArray* _vala_JsonArray_copy (JsonArray* self);
static void _vala_JsonArray_free (JsonArray* self);
static void server_repl_do_poll_output (ServerRepl* self, JsonNode* params, ServerResponse* result);
static void server_repl_do_get_segments (ServerRepl* self, JsonNode* params, ServerResponse* result);
static void server_repl_do_get_input (ServerRepl* self, JsonNode* params, ServerResponse* result);
static void server_repl_do_reset (ServerRepl* self, JsonNode* params, ServerResponse* result);
ServerRepl* server_repl_new (void);
ServerRepl* server_repl_construct (GType object_type);
static GObject * server_repl_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _server_repl_do_process_key_events_command_callback (JsonNode* params, ServerResponse* result, gpointer self);
static void _server_repl_do_poll_output_command_callback (JsonNode* params, ServerResponse* result, gpointer self);
static void _server_repl_do_get_segments_command_callback (JsonNode* params, ServerResponse* result, gpointer self);
static void _server_repl_do_get_input_command_callback (JsonNode* params, ServerResponse* result, gpointer self);
static void _server_repl_do_reset_command_callback (JsonNode* params, ServerResponse* result, gpointer self);
static void server_repl_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

extern const GOptionEntry context_entries[4];

GType server_error_code_get_type (void) {
	static volatile gsize server_error_code_type_id__volatile = 0;
	if (g_once_init_enter (&server_error_code_type_id__volatile)) {
		static const GEnumValue values[] = {{SERVER_ERROR_CODE_PARSE_ERROR, "SERVER_ERROR_CODE_PARSE_ERROR", "parse-error"}, {SERVER_ERROR_CODE_INVALID_REQUEST, "SERVER_ERROR_CODE_INVALID_REQUEST", "invalid-request"}, {SERVER_ERROR_CODE_METHOD_NOT_FOUND, "SERVER_ERROR_CODE_METHOD_NOT_FOUND", "method-not-found"}, {SERVER_ERROR_CODE_INVALID_PARAMS, "SERVER_ERROR_CODE_INVALID_PARAMS", "invalid-params"}, {SERVER_ERROR_CODE_INTERNAL_ERROR, "SERVER_ERROR_CODE_INTERNAL_ERROR", "internal-error"}, {0, NULL, NULL}};
		GType server_error_code_type_id;
		server_error_code_type_id = g_enum_register_static ("ServerErrorCode", values);
		g_once_init_leave (&server_error_code_type_id__volatile, server_error_code_type_id);
	}
	return server_error_code_type_id__volatile;
}


static void _vala_JsonNode_free (JsonNode* self) {
	g_boxed_free (json_node_get_type (), self);
}


void server_error_append (ServerError *self, JsonBuilder* builder) {
	JsonBuilder* _tmp0_;
	JsonBuilder* _tmp1_;
	JsonBuilder* _tmp2_;
	ServerErrorCode _tmp3_;
	JsonBuilder* _tmp4_;
	JsonBuilder* _tmp5_;
	const gchar* _tmp6_;
	JsonNode* _tmp7_;
	JsonBuilder* _tmp11_;
	g_return_if_fail (builder != NULL);
	_tmp0_ = builder;
	json_builder_begin_object (_tmp0_);
	_tmp1_ = builder;
	json_builder_set_member_name (_tmp1_, "code");
	_tmp2_ = builder;
	_tmp3_ = (*self).code;
	json_builder_add_int_value (_tmp2_, (gint64) _tmp3_);
	_tmp4_ = builder;
	json_builder_set_member_name (_tmp4_, "message");
	_tmp5_ = builder;
	_tmp6_ = (*self).message;
	json_builder_add_string_value (_tmp5_, _tmp6_);
	_tmp7_ = (*self).data;
	if (_tmp7_ != NULL) {
		JsonBuilder* _tmp8_;
		JsonBuilder* _tmp9_;
		JsonNode* _tmp10_;
		_tmp8_ = builder;
		json_builder_set_member_name (_tmp8_, "data");
		_tmp9_ = builder;
		_tmp10_ = (*self).data;
		json_builder_add_value (_tmp9_, _tmp10_);
	}
	_tmp11_ = builder;
	json_builder_end_object (_tmp11_);
}


static JsonNode* _vala_JsonNode_copy (JsonNode* self) {
	return g_boxed_copy (json_node_get_type (), self);
}


static gpointer __vala_JsonNode_copy0 (gpointer self) {
	return self ? _vala_JsonNode_copy (self) : NULL;
}


void server_error_copy (const ServerError* self, ServerError* dest) {
	ServerErrorCode _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	JsonNode* _tmp3_;
	JsonNode* _tmp4_;
	_tmp0_ = (*self).code;
	(*dest).code = _tmp0_;
	_tmp1_ = (*self).message;
	_tmp2_ = g_strdup (_tmp1_);
	_g_free0 ((*dest).message);
	(*dest).message = _tmp2_;
	_tmp3_ = (*self).data;
	_tmp4_ = __vala_JsonNode_copy0 (_tmp3_);
	__vala_JsonNode_free0 ((*dest).data);
	(*dest).data = _tmp4_;
}


void server_error_destroy (ServerError* self) {
	_g_free0 ((*self).message);
	__vala_JsonNode_free0 ((*self).data);
}


ServerError* server_error_dup (const ServerError* self) {
	ServerError* dup;
	dup = g_new0 (ServerError, 1);
	server_error_copy (self, dup);
	return dup;
}


void server_error_free (ServerError* self) {
	server_error_destroy (self);
	g_free (self);
}


GType server_error_get_type (void) {
	static volatile gsize server_error_type_id__volatile = 0;
	if (g_once_init_enter (&server_error_type_id__volatile)) {
		GType server_error_type_id;
		server_error_type_id = g_boxed_type_register_static ("ServerError", (GBoxedCopyFunc) server_error_dup, (GBoxedFreeFunc) server_error_free);
		g_once_init_leave (&server_error_type_id__volatile, server_error_type_id);
	}
	return server_error_type_id__volatile;
}


void server_response_append (ServerResponse *self, JsonBuilder* builder, JsonNode* id) {
	gboolean _tmp0_ = FALSE;
	JsonNode* _tmp1_;
	gboolean _tmp3_;
	JsonBuilder* _tmp4_;
	JsonBuilder* _tmp5_;
	JsonBuilder* _tmp6_;
	JsonNode* _tmp7_;
	ServerError* _tmp11_;
	JsonNode* _tmp15_;
	JsonBuilder* _tmp19_;
	g_return_if_fail (builder != NULL);
	_tmp1_ = (*self).result;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		ServerError* _tmp2_;
		_tmp2_ = (*self).error;
		_tmp0_ = _tmp2_ == NULL;
	}
	_tmp3_ = _tmp0_;
	g_return_if_fail (_tmp3_);
	_tmp4_ = builder;
	json_builder_begin_object (_tmp4_);
	_tmp5_ = builder;
	json_builder_set_member_name (_tmp5_, "jsonrpc");
	_tmp6_ = builder;
	json_builder_add_string_value (_tmp6_, "2.0");
	_tmp7_ = (*self).result;
	if (_tmp7_ != NULL) {
		JsonBuilder* _tmp8_;
		JsonBuilder* _tmp9_;
		JsonNode* _tmp10_;
		_tmp8_ = builder;
		json_builder_set_member_name (_tmp8_, "result");
		_tmp9_ = builder;
		_tmp10_ = (*self).result;
		json_builder_add_value (_tmp9_, _tmp10_);
	}
	_tmp11_ = (*self).error;
	if (_tmp11_ != NULL) {
		JsonBuilder* _tmp12_;
		ServerError* _tmp13_;
		JsonBuilder* _tmp14_;
		_tmp12_ = builder;
		json_builder_set_member_name (_tmp12_, "error");
		_tmp13_ = (*self).error;
		_tmp14_ = builder;
		server_error_append (_tmp13_, _tmp14_);
	}
	_tmp15_ = id;
	if (_tmp15_ != NULL) {
		JsonBuilder* _tmp16_;
		JsonBuilder* _tmp17_;
		JsonNode* _tmp18_;
		_tmp16_ = builder;
		json_builder_set_member_name (_tmp16_, "id");
		_tmp17_ = builder;
		_tmp18_ = id;
		json_builder_add_value (_tmp17_, _tmp18_);
	}
	_tmp19_ = builder;
	json_builder_end_object (_tmp19_);
}


static gpointer _server_error_dup0 (gpointer self) {
	return self ? server_error_dup (self) : NULL;
}


void server_response_copy (const ServerResponse* self, ServerResponse* dest) {
	JsonNode* _tmp0_;
	JsonNode* _tmp1_;
	ServerError* _tmp2_;
	ServerError* _tmp3_;
	_tmp0_ = (*self).result;
	_tmp1_ = __vala_JsonNode_copy0 (_tmp0_);
	__vala_JsonNode_free0 ((*dest).result);
	(*dest).result = _tmp1_;
	_tmp2_ = (*self).error;
	_tmp3_ = _server_error_dup0 (_tmp2_);
	_server_error_free0 ((*dest).error);
	(*dest).error = _tmp3_;
}


void server_response_destroy (ServerResponse* self) {
	__vala_JsonNode_free0 ((*self).result);
	_server_error_free0 ((*self).error);
}


ServerResponse* server_response_dup (const ServerResponse* self) {
	ServerResponse* dup;
	dup = g_new0 (ServerResponse, 1);
	server_response_copy (self, dup);
	return dup;
}


void server_response_free (ServerResponse* self) {
	server_response_destroy (self);
	g_free (self);
}


GType server_response_get_type (void) {
	static volatile gsize server_response_type_id__volatile = 0;
	if (g_once_init_enter (&server_response_type_id__volatile)) {
		GType server_response_type_id;
		server_response_type_id = g_boxed_type_register_static ("ServerResponse", (GBoxedCopyFunc) server_response_dup, (GBoxedFreeFunc) server_response_free);
		g_once_init_leave (&server_response_type_id__volatile, server_response_type_id);
	}
	return server_response_type_id__volatile;
}


CommandHandler* command_handler_construct (GType object_type, CommandCallback cb, void* cb_target) {
	CommandHandler * self = NULL;
	CommandCallback _tmp0_;
	void* _tmp0__target;
	self = (CommandHandler*) g_object_new (object_type, NULL);
	_tmp0_ = cb;
	_tmp0__target = cb_target;
	self->priv->cb = _tmp0_;
	self->priv->cb_target = _tmp0__target;
	return self;
}


CommandHandler* command_handler_new (CommandCallback cb, void* cb_target) {
	return command_handler_construct (TYPE_COMMAND_HANDLER, cb, cb_target);
}


void command_handler_call (CommandHandler* self, JsonNode* params, ServerResponse* result) {
	CommandCallback _tmp0_;
	void* _tmp0__target;
	JsonNode* _tmp1_;
	ServerResponse _tmp2_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->cb;
	_tmp0__target = self->priv->cb_target;
	_tmp1_ = params;
	_tmp0_ (_tmp1_, &_tmp2_, _tmp0__target);
	*result = _tmp2_;
	return;
}


static void command_handler_class_init (CommandHandlerClass * klass) {
	command_handler_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (CommandHandlerPrivate));
	G_OBJECT_CLASS (klass)->finalize = command_handler_finalize;
}


static void command_handler_instance_init (CommandHandler * self) {
	self->priv = COMMAND_HANDLER_GET_PRIVATE (self);
}


static void command_handler_finalize (GObject* obj) {
	CommandHandler * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COMMAND_HANDLER, CommandHandler);
	G_OBJECT_CLASS (command_handler_parent_class)->finalize (obj);
}


GType command_handler_get_type (void) {
	static volatile gsize command_handler_type_id__volatile = 0;
	if (g_once_init_enter (&command_handler_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CommandHandlerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) command_handler_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CommandHandler), 0, (GInstanceInitFunc) command_handler_instance_init, NULL };
		GType command_handler_type_id;
		command_handler_type_id = g_type_register_static (G_TYPE_OBJECT, "CommandHandler", &g_define_type_info, 0);
		g_once_init_leave (&command_handler_type_id__volatile, command_handler_type_id);
	}
	return command_handler_type_id__volatile;
}


static gboolean server_repl_real_parse_arguments (Repl* base, gchar** args, int args_length1, GError** error) {
	ServerRepl * self;
	gboolean result = FALSE;
	GOptionContext* o = NULL;
	const gchar* _tmp0_ = NULL;
	GOptionContext* _tmp1_;
	GOptionGroup* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	GError * _inner_error_ = NULL;
	self = (ServerRepl*) base;
	_tmp0_ = _ ("- run context on the command line");
	_tmp1_ = g_option_context_new (_tmp0_);
	o = _tmp1_;
	g_option_context_add_main_entries (o, context_entries, "libkkc");
	_tmp2_ = model_group;
	model_group = NULL;
	g_option_context_add_group (o, _tmp2_);
	_tmp4_ = g_option_context_parse (o, &args_length1, &args, &_inner_error_);
	_tmp3_ = _tmp4_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_option_context_free0 (o);
		return FALSE;
	}
	result = _tmp3_;
	_g_option_context_free0 (o);
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gchar* g_file_stream_read_line (FILE* self) {
	gchar* result = NULL;
	gint c = 0;
	GString* ret = NULL;
	GString* _tmp7_;
	g_return_val_if_fail (self != NULL, NULL);
	ret = NULL;
	while (TRUE) {
		gint _tmp0_ = 0;
		gint _tmp1_;
		GString* _tmp2_;
		gint _tmp4_;
		GString* _tmp5_;
		gint _tmp6_;
		_tmp0_ = fgetc (self);
		c = _tmp0_;
		_tmp1_ = c;
		if (!(_tmp1_ != EOF)) {
			break;
		}
		_tmp2_ = ret;
		if (_tmp2_ == NULL) {
			GString* _tmp3_;
			_tmp3_ = g_string_new ("");
			_g_string_free0 (ret);
			ret = _tmp3_;
		}
		_tmp4_ = c;
		if (_tmp4_ == ((gint) '\n')) {
			break;
		}
		_tmp5_ = ret;
		_tmp6_ = c;
		g_string_append_c ((GString*) _tmp5_, (gchar) _tmp6_);
	}
	_tmp7_ = ret;
	if (_tmp7_ == NULL) {
		result = NULL;
		_g_string_free0 (ret);
		return result;
	} else {
		GString* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp8_ = ret;
		_tmp9_ = ((GString*) _tmp8_)->str;
		_tmp10_ = g_strdup (_tmp9_);
		result = _tmp10_;
		_g_string_free0 (ret);
		return result;
	}
	_g_string_free0 (ret);
}


static JsonObject* _vala_JsonObject_copy (JsonObject* self) {
	return g_boxed_copy (json_object_get_type (), self);
}


static gpointer __vala_JsonObject_copy0 (gpointer self) {
	return self ? _vala_JsonObject_copy (self) : NULL;
}


static void _vala_JsonObject_free (JsonObject* self) {
	g_boxed_free (json_object_get_type (), self);
}


static gboolean server_repl_real_run (Repl* base, GError** error) {
	ServerRepl * self;
	gboolean result = FALSE;
	const gchar* _tmp0_;
	KkcLanguageModel* model = NULL;
	KkcLanguageModel* _tmp26_;
	KkcContext* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp40_;
	const gchar* _tmp53_;
	gchar* line = NULL;
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp65_;
	JsonParser* parser = NULL;
	JsonParser* _tmp66_;
	GError * _inner_error_ = NULL;
	self = (ServerRepl*) base;
	_tmp0_ = opt_typing_rule;
	if (g_strcmp0 (_tmp0_, "?") == 0) {
		KkcRuleMetadata** rules = NULL;
		gint _tmp1_ = 0;
		KkcRuleMetadata** _tmp2_ = NULL;
		gint rules_length1;
		gint _rules_size_;
		KkcRuleMetadata** _tmp3_;
		gint _tmp3__length1;
		_tmp2_ = kkc_rule_list (&_tmp1_);
		rules = _tmp2_;
		rules_length1 = _tmp1_;
		_rules_size_ = rules_length1;
		_tmp3_ = rules;
		_tmp3__length1 = rules_length1;
		{
			KkcRuleMetadata** rule_collection = NULL;
			gint rule_collection_length1 = 0;
			gint _rule_collection_size_ = 0;
			gint rule_it = 0;
			rule_collection = _tmp3_;
			rule_collection_length1 = _tmp3__length1;
			for (rule_it = 0; rule_it < _tmp3__length1; rule_it = rule_it + 1) {
				KkcRuleMetadata* _tmp4_;
				KkcRuleMetadata* rule = NULL;
				_tmp4_ = _g_object_ref0 (rule_collection[rule_it]);
				rule = _tmp4_;
				{
					FILE* _tmp5_;
					KkcRuleMetadata* _tmp6_;
					const gchar* _tmp7_;
					const gchar* _tmp8_;
					KkcRuleMetadata* _tmp9_;
					const gchar* _tmp10_;
					const gchar* _tmp11_;
					KkcRuleMetadata* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					_tmp5_ = stdout;
					_tmp6_ = rule;
					_tmp7_ = kkc_metadata_file_get_name ((KkcMetadataFile*) _tmp6_);
					_tmp8_ = _tmp7_;
					_tmp9_ = rule;
					_tmp10_ = kkc_metadata_file_get_label ((KkcMetadataFile*) _tmp9_);
					_tmp11_ = _tmp10_;
					_tmp12_ = rule;
					_tmp13_ = kkc_metadata_file_get_description ((KkcMetadataFile*) _tmp12_);
					_tmp14_ = _tmp13_;
					fprintf (_tmp5_, "%s - %s: %s\n", _tmp8_, _tmp11_, _tmp14_);
					_g_object_unref0 (rule);
				}
			}
		}
		result = TRUE;
		rules = (_vala_array_free (rules, rules_length1, (GDestroyNotify) g_object_unref), NULL);
		return result;
	}
	{
		const gchar* _tmp15_ = NULL;
		const gchar* _tmp16_;
		gchar* name = NULL;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		KkcLanguageModel* _tmp20_ = NULL;
		const gchar* _tmp21_;
		KkcLanguageModel* _tmp22_ = NULL;
		_tmp16_ = opt_model;
		if (_tmp16_ == NULL) {
			_tmp15_ = "sorted3";
		} else {
			const gchar* _tmp17_;
			_tmp17_ = opt_model;
			_tmp15_ = _tmp17_;
		}
		_tmp18_ = _tmp15_;
		_tmp19_ = g_strdup (_tmp18_);
		name = _tmp19_;
		_tmp21_ = name;
		_tmp22_ = kkc_language_model_load (_tmp21_, &_inner_error_);
		_tmp20_ = _tmp22_;
		if (_inner_error_ != NULL) {
			_g_free0 (name);
			if (_inner_error_->domain == KKC_LANGUAGE_MODEL_ERROR) {
				goto __catch9_kkc_language_model_error;
			}
			goto __finally9;
		}
		_g_object_unref0 (model);
		model = _tmp20_;
		_g_free0 (name);
	}
	goto __finally9;
	__catch9_kkc_language_model_error:
	{
		GError* e = NULL;
		FILE* _tmp23_;
		GError* _tmp24_;
		const gchar* _tmp25_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp23_ = stderr;
		_tmp24_ = e;
		_tmp25_ = _tmp24_->message;
		fprintf (_tmp23_, "%s\n", _tmp25_);
		result = FALSE;
		_g_error_free0 (e);
		_g_object_unref0 (model);
		return result;
	}
	__finally9:
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (model);
		return FALSE;
	}
	_tmp26_ = model;
	_tmp27_ = kkc_context_new (_tmp26_);
	_g_object_unref0 (self->priv->context);
	self->priv->context = _tmp27_;
	_tmp28_ = opt_user_dictionary;
	if (_tmp28_ != NULL) {
		{
			KkcUserDictionary* _tmp29_ = NULL;
			const gchar* _tmp30_;
			KkcUserDictionary* _tmp31_;
			KkcContext* _tmp32_;
			KkcDictionaryList* _tmp33_;
			KkcDictionaryList* _tmp34_;
			KkcUserDictionary* _tmp35_;
			_tmp30_ = opt_user_dictionary;
			_tmp31_ = kkc_user_dictionary_new (_tmp30_, &_inner_error_);
			_tmp29_ = _tmp31_;
			if (_inner_error_ != NULL) {
				goto __catch10_g_error;
			}
			_tmp32_ = self->priv->context;
			_tmp33_ = kkc_context_get_dictionaries (_tmp32_);
			_tmp34_ = _tmp33_;
			_tmp35_ = _tmp29_;
			kkc_dictionary_list_add (_tmp34_, (KkcDictionary*) _tmp35_);
			_g_object_unref0 (_tmp35_);
		}
		goto __finally10;
		__catch10_g_error:
		{
			GError* e = NULL;
			FILE* _tmp36_;
			const gchar* _tmp37_;
			GError* _tmp38_;
			const gchar* _tmp39_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp36_ = stderr;
			_tmp37_ = opt_user_dictionary;
			_tmp38_ = e;
			_tmp39_ = _tmp38_->message;
			fprintf (_tmp36_, "can't open user dictionary %s: %s", _tmp37_, _tmp39_);
			result = FALSE;
			_g_error_free0 (e);
			_g_object_unref0 (model);
			return result;
		}
		__finally10:
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (model);
			return FALSE;
		}
	}
	_tmp40_ = opt_system_dictionary;
	if (_tmp40_ == NULL) {
		gchar* _tmp41_ = NULL;
		_tmp41_ = g_build_filename (DATADIR, "skk", "SKK-JISYO.L", NULL);
		_g_free0 (opt_system_dictionary);
		opt_system_dictionary = _tmp41_;
	}
	{
		KkcSystemSegmentDictionary* _tmp42_ = NULL;
		const gchar* _tmp43_;
		KkcSystemSegmentDictionary* _tmp44_;
		KkcContext* _tmp45_;
		KkcDictionaryList* _tmp46_;
		KkcDictionaryList* _tmp47_;
		KkcSystemSegmentDictionary* _tmp48_;
		_tmp43_ = opt_system_dictionary;
		_tmp44_ = kkc_system_segment_dictionary_new (_tmp43_, "EUC-JP", &_inner_error_);
		_tmp42_ = _tmp44_;
		if (_inner_error_ != NULL) {
			goto __catch11_g_error;
		}
		_tmp45_ = self->priv->context;
		_tmp46_ = kkc_context_get_dictionaries (_tmp45_);
		_tmp47_ = _tmp46_;
		_tmp48_ = _tmp42_;
		kkc_dictionary_list_add (_tmp47_, (KkcDictionary*) _tmp48_);
		_g_object_unref0 (_tmp48_);
	}
	goto __finally11;
	__catch11_g_error:
	{
		GError* e = NULL;
		FILE* _tmp49_;
		const gchar* _tmp50_;
		GError* _tmp51_;
		const gchar* _tmp52_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp49_ = stderr;
		_tmp50_ = opt_system_dictionary;
		_tmp51_ = e;
		_tmp52_ = _tmp51_->message;
		fprintf (_tmp49_, "can't open system dictionary %s: %s", _tmp50_, _tmp52_);
		result = FALSE;
		_g_error_free0 (e);
		_g_object_unref0 (model);
		return result;
	}
	__finally11:
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (model);
		return FALSE;
	}
	_tmp53_ = opt_typing_rule;
	if (_tmp53_ != NULL) {
		{
			KkcRuleMetadata* metadata = NULL;
			const gchar* _tmp54_;
			KkcRuleMetadata* _tmp55_ = NULL;
			KkcRule* _tmp56_ = NULL;
			KkcRuleMetadata* _tmp57_;
			KkcRule* _tmp58_;
			KkcContext* _tmp59_;
			KkcRule* _tmp60_;
			_tmp54_ = opt_typing_rule;
			_tmp55_ = kkc_rule_metadata_find (_tmp54_);
			metadata = _tmp55_;
			_tmp57_ = metadata;
			_tmp58_ = kkc_rule_new (_tmp57_, &_inner_error_);
			_tmp56_ = _tmp58_;
			if (_inner_error_ != NULL) {
				_g_object_unref0 (metadata);
				if (_inner_error_->domain == KKC_RULE_PARSE_ERROR) {
					goto __catch12_kkc_rule_parse_error;
				}
				goto __finally12;
			}
			_tmp59_ = self->priv->context;
			_tmp60_ = _tmp56_;
			kkc_context_set_typing_rule (_tmp59_, _tmp60_);
			_g_object_unref0 (_tmp60_);
			_g_object_unref0 (metadata);
		}
		goto __finally12;
		__catch12_kkc_rule_parse_error:
		{
			GError* e = NULL;
			FILE* _tmp61_;
			const gchar* _tmp62_;
			GError* _tmp63_;
			const gchar* _tmp64_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp61_ = stderr;
			_tmp62_ = opt_typing_rule;
			_tmp63_ = e;
			_tmp64_ = _tmp63_->message;
			fprintf (_tmp61_, "can't load rule \"%s\": %s\n", _tmp62_, _tmp64_);
			result = FALSE;
			_g_error_free0 (e);
			_g_object_unref0 (model);
			return result;
		}
		__finally12:
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (model);
			return FALSE;
		}
	}
	_tmp65_ = json_generator_new ();
	generator = _tmp65_;
	_tmp66_ = json_parser_new ();
	parser = _tmp66_;
	while (TRUE) {
		FILE* _tmp67_;
		gchar* _tmp68_ = NULL;
		const gchar* _tmp69_;
		JsonNode* root = NULL;
		JsonParser* _tmp86_;
		JsonNode* _tmp87_ = NULL;
		JsonNode* _tmp88_;
		JsonNode* _tmp89_;
		JsonNodeType _tmp90_ = 0;
		JsonObject* object = NULL;
		JsonNode* _tmp103_;
		JsonObject* _tmp104_ = NULL;
		JsonObject* _tmp105_;
		JsonObject* _tmp106_;
		gboolean _tmp107_ = FALSE;
		gchar* jsonrpc = NULL;
		JsonObject* _tmp120_;
		const gchar* _tmp121_ = NULL;
		gchar* _tmp122_;
		const gchar* _tmp123_;
		JsonObject* _tmp140_;
		gboolean _tmp141_ = FALSE;
		gchar* method = NULL;
		JsonObject* _tmp154_;
		const gchar* _tmp155_ = NULL;
		gchar* _tmp156_;
		GeeMap* _tmp157_;
		const gchar* _tmp158_;
		gboolean _tmp159_ = FALSE;
		JsonNode* params = NULL;
		JsonObject* _tmp176_;
		gboolean _tmp177_ = FALSE;
		JsonNode* id = NULL;
		JsonObject* _tmp181_;
		gboolean _tmp182_ = FALSE;
		CommandHandler* handler = NULL;
		GeeMap* _tmp186_;
		const gchar* _tmp187_;
		gpointer _tmp188_ = NULL;
		ServerResponse response = {0};
		CommandHandler* _tmp189_;
		JsonNode* _tmp190_;
		ServerResponse _tmp191_ = {0};
		JsonBuilder* builder = NULL;
		JsonBuilder* _tmp192_;
		JsonBuilder* _tmp193_;
		JsonNode* _tmp194_;
		JsonGenerator* _tmp195_;
		JsonBuilder* _tmp196_;
		JsonNode* _tmp197_ = NULL;
		JsonNode* _tmp198_;
		gsize length = 0UL;
		FILE* _tmp199_;
		JsonGenerator* _tmp200_;
		gsize _tmp201_ = 0UL;
		gchar* _tmp202_ = NULL;
		gchar* _tmp203_;
		GMainContext* _tmp204_ = NULL;
		_tmp67_ = stdin;
		_tmp68_ = g_file_stream_read_line (_tmp67_);
		_g_free0 (line);
		line = _tmp68_;
		_tmp69_ = line;
		if (!(_tmp69_ != NULL)) {
			break;
		}
		{
			JsonParser* _tmp70_;
			const gchar* _tmp71_;
			_tmp70_ = parser;
			_tmp71_ = line;
			json_parser_load_from_data (_tmp70_, _tmp71_, (gssize) (-1), &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch13_g_error;
			}
		}
		goto __finally13;
		__catch13_g_error:
		{
			GError* e = NULL;
			ServerResponse response = {0};
			GError* _tmp72_;
			const gchar* _tmp73_;
			ServerResponse _tmp74_ = {0};
			JsonBuilder* builder = NULL;
			JsonBuilder* _tmp75_;
			JsonBuilder* _tmp76_;
			JsonGenerator* _tmp77_;
			JsonBuilder* _tmp78_;
			JsonNode* _tmp79_ = NULL;
			JsonNode* _tmp80_;
			gsize length = 0UL;
			FILE* _tmp81_;
			JsonGenerator* _tmp82_;
			gsize _tmp83_ = 0UL;
			gchar* _tmp84_ = NULL;
			gchar* _tmp85_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp72_ = e;
			_tmp73_ = _tmp72_->message;
			server_repl_create_error_response (self, SERVER_ERROR_CODE_PARSE_ERROR, _tmp73_, NULL, &_tmp74_);
			response = _tmp74_;
			_tmp75_ = json_builder_new ();
			builder = _tmp75_;
			_tmp76_ = builder;
			server_response_append (&response, _tmp76_, NULL);
			_tmp77_ = generator;
			_tmp78_ = builder;
			_tmp79_ = json_builder_get_root (_tmp78_);
			_tmp80_ = _tmp79_;
			json_generator_set_root (_tmp77_, _tmp80_);
			__vala_JsonNode_free0 (_tmp80_);
			_tmp81_ = stdout;
			_tmp82_ = generator;
			_tmp84_ = json_generator_to_data (_tmp82_, &_tmp83_);
			length = _tmp83_;
			_tmp85_ = _tmp84_;
			fprintf (_tmp81_, "%s\n", _tmp85_);
			_g_free0 (_tmp85_);
			_g_object_unref0 (builder);
			server_response_destroy (&response);
			_g_error_free0 (e);
			continue;
		}
		__finally13:
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (parser);
			_g_object_unref0 (generator);
			_g_free0 (line);
			_g_object_unref0 (model);
			return FALSE;
		}
		_tmp86_ = parser;
		_tmp87_ = json_parser_get_root (_tmp86_);
		_tmp88_ = __vala_JsonNode_copy0 (_tmp87_);
		root = _tmp88_;
		_tmp89_ = root;
		_tmp90_ = json_node_get_node_type (_tmp89_);
		if (_tmp90_ != JSON_NODE_OBJECT) {
			ServerResponse response = {0};
			ServerResponse _tmp91_ = {0};
			JsonBuilder* builder = NULL;
			JsonBuilder* _tmp92_;
			JsonBuilder* _tmp93_;
			JsonGenerator* _tmp94_;
			JsonBuilder* _tmp95_;
			JsonNode* _tmp96_ = NULL;
			JsonNode* _tmp97_;
			gsize length = 0UL;
			FILE* _tmp98_;
			JsonGenerator* _tmp99_;
			gsize _tmp100_ = 0UL;
			gchar* _tmp101_ = NULL;
			gchar* _tmp102_;
			server_repl_create_error_response (self, SERVER_ERROR_CODE_INVALID_REQUEST, "request is not an object", NULL, &_tmp91_);
			response = _tmp91_;
			_tmp92_ = json_builder_new ();
			builder = _tmp92_;
			_tmp93_ = builder;
			server_response_append (&response, _tmp93_, NULL);
			_tmp94_ = generator;
			_tmp95_ = builder;
			_tmp96_ = json_builder_get_root (_tmp95_);
			_tmp97_ = _tmp96_;
			json_generator_set_root (_tmp94_, _tmp97_);
			__vala_JsonNode_free0 (_tmp97_);
			_tmp98_ = stdout;
			_tmp99_ = generator;
			_tmp101_ = json_generator_to_data (_tmp99_, &_tmp100_);
			length = _tmp100_;
			_tmp102_ = _tmp101_;
			fprintf (_tmp98_, "%s\n", _tmp102_);
			_g_free0 (_tmp102_);
			_g_object_unref0 (builder);
			server_response_destroy (&response);
			__vala_JsonNode_free0 (root);
			continue;
		}
		_tmp103_ = root;
		_tmp104_ = json_node_get_object (_tmp103_);
		_tmp105_ = __vala_JsonObject_copy0 (_tmp104_);
		object = _tmp105_;
		_tmp106_ = object;
		_tmp107_ = json_object_has_member (_tmp106_, "jsonrpc");
		if (!_tmp107_) {
			ServerResponse response = {0};
			ServerResponse _tmp108_ = {0};
			JsonBuilder* builder = NULL;
			JsonBuilder* _tmp109_;
			JsonBuilder* _tmp110_;
			JsonGenerator* _tmp111_;
			JsonBuilder* _tmp112_;
			JsonNode* _tmp113_ = NULL;
			JsonNode* _tmp114_;
			gsize length = 0UL;
			FILE* _tmp115_;
			JsonGenerator* _tmp116_;
			gsize _tmp117_ = 0UL;
			gchar* _tmp118_ = NULL;
			gchar* _tmp119_;
			server_repl_create_error_response (self, SERVER_ERROR_CODE_INVALID_REQUEST, "missing jsonrpc member", NULL, &_tmp108_);
			response = _tmp108_;
			_tmp109_ = json_builder_new ();
			builder = _tmp109_;
			_tmp110_ = builder;
			server_response_append (&response, _tmp110_, NULL);
			_tmp111_ = generator;
			_tmp112_ = builder;
			_tmp113_ = json_builder_get_root (_tmp112_);
			_tmp114_ = _tmp113_;
			json_generator_set_root (_tmp111_, _tmp114_);
			__vala_JsonNode_free0 (_tmp114_);
			_tmp115_ = stdout;
			_tmp116_ = generator;
			_tmp118_ = json_generator_to_data (_tmp116_, &_tmp117_);
			length = _tmp117_;
			_tmp119_ = _tmp118_;
			fprintf (_tmp115_, "%s\n", _tmp119_);
			_g_free0 (_tmp119_);
			_g_object_unref0 (builder);
			server_response_destroy (&response);
			__vala_JsonObject_free0 (object);
			__vala_JsonNode_free0 (root);
			continue;
		}
		_tmp120_ = object;
		_tmp121_ = json_object_get_string_member (_tmp120_, "jsonrpc");
		_tmp122_ = g_strdup (_tmp121_);
		jsonrpc = _tmp122_;
		_tmp123_ = jsonrpc;
		if (g_strcmp0 (_tmp123_, "2.0") != 0) {
			ServerResponse response = {0};
			const gchar* _tmp124_;
			gchar* _tmp125_ = NULL;
			gchar* _tmp126_;
			ServerResponse _tmp127_ = {0};
			ServerResponse _tmp128_;
			JsonBuilder* builder = NULL;
			JsonBuilder* _tmp129_;
			JsonBuilder* _tmp130_;
			JsonGenerator* _tmp131_;
			JsonBuilder* _tmp132_;
			JsonNode* _tmp133_ = NULL;
			JsonNode* _tmp134_;
			gsize length = 0UL;
			FILE* _tmp135_;
			JsonGenerator* _tmp136_;
			gsize _tmp137_ = 0UL;
			gchar* _tmp138_ = NULL;
			gchar* _tmp139_;
			_tmp124_ = jsonrpc;
			_tmp125_ = g_strdup_printf ("unsupported jsonrpc version %s", _tmp124_);
			_tmp126_ = _tmp125_;
			server_repl_create_error_response (self, SERVER_ERROR_CODE_INVALID_REQUEST, _tmp126_, NULL, &_tmp127_);
			_tmp128_ = _tmp127_;
			_g_free0 (_tmp126_);
			response = _tmp128_;
			_tmp129_ = json_builder_new ();
			builder = _tmp129_;
			_tmp130_ = builder;
			server_response_append (&response, _tmp130_, NULL);
			_tmp131_ = generator;
			_tmp132_ = builder;
			_tmp133_ = json_builder_get_root (_tmp132_);
			_tmp134_ = _tmp133_;
			json_generator_set_root (_tmp131_, _tmp134_);
			__vala_JsonNode_free0 (_tmp134_);
			_tmp135_ = stdout;
			_tmp136_ = generator;
			_tmp138_ = json_generator_to_data (_tmp136_, &_tmp137_);
			length = _tmp137_;
			_tmp139_ = _tmp138_;
			fprintf (_tmp135_, "%s\n", _tmp139_);
			_g_free0 (_tmp139_);
			_g_object_unref0 (builder);
			server_response_destroy (&response);
			_g_free0 (jsonrpc);
			__vala_JsonObject_free0 (object);
			__vala_JsonNode_free0 (root);
			continue;
		}
		_tmp140_ = object;
		_tmp141_ = json_object_has_member (_tmp140_, "method");
		if (!_tmp141_) {
			ServerResponse response = {0};
			ServerResponse _tmp142_ = {0};
			JsonBuilder* builder = NULL;
			JsonBuilder* _tmp143_;
			JsonBuilder* _tmp144_;
			JsonGenerator* _tmp145_;
			JsonBuilder* _tmp146_;
			JsonNode* _tmp147_ = NULL;
			JsonNode* _tmp148_;
			gsize length = 0UL;
			FILE* _tmp149_;
			JsonGenerator* _tmp150_;
			gsize _tmp151_ = 0UL;
			gchar* _tmp152_ = NULL;
			gchar* _tmp153_;
			server_repl_create_error_response (self, SERVER_ERROR_CODE_INVALID_REQUEST, "no method member", NULL, &_tmp142_);
			response = _tmp142_;
			_tmp143_ = json_builder_new ();
			builder = _tmp143_;
			_tmp144_ = builder;
			server_response_append (&response, _tmp144_, NULL);
			_tmp145_ = generator;
			_tmp146_ = builder;
			_tmp147_ = json_builder_get_root (_tmp146_);
			_tmp148_ = _tmp147_;
			json_generator_set_root (_tmp145_, _tmp148_);
			__vala_JsonNode_free0 (_tmp148_);
			_tmp149_ = stdout;
			_tmp150_ = generator;
			_tmp152_ = json_generator_to_data (_tmp150_, &_tmp151_);
			length = _tmp151_;
			_tmp153_ = _tmp152_;
			fprintf (_tmp149_, "%s\n", _tmp153_);
			_g_free0 (_tmp153_);
			_g_object_unref0 (builder);
			server_response_destroy (&response);
			_g_free0 (jsonrpc);
			__vala_JsonObject_free0 (object);
			__vala_JsonNode_free0 (root);
			continue;
		}
		_tmp154_ = object;
		_tmp155_ = json_object_get_string_member (_tmp154_, "method");
		_tmp156_ = g_strdup (_tmp155_);
		method = _tmp156_;
		_tmp157_ = self->priv->command_handlers;
		_tmp158_ = method;
		_tmp159_ = gee_map_has_key (_tmp157_, _tmp158_);
		if (!_tmp159_) {
			ServerResponse response = {0};
			const gchar* _tmp160_;
			gchar* _tmp161_ = NULL;
			gchar* _tmp162_;
			ServerResponse _tmp163_ = {0};
			ServerResponse _tmp164_;
			JsonBuilder* builder = NULL;
			JsonBuilder* _tmp165_;
			JsonBuilder* _tmp166_;
			JsonGenerator* _tmp167_;
			JsonBuilder* _tmp168_;
			JsonNode* _tmp169_ = NULL;
			JsonNode* _tmp170_;
			gsize length = 0UL;
			FILE* _tmp171_;
			JsonGenerator* _tmp172_;
			gsize _tmp173_ = 0UL;
			gchar* _tmp174_ = NULL;
			gchar* _tmp175_;
			_tmp160_ = method;
			_tmp161_ = g_strdup_printf ("no such method %s", _tmp160_);
			_tmp162_ = _tmp161_;
			server_repl_create_error_response (self, SERVER_ERROR_CODE_METHOD_NOT_FOUND, _tmp162_, NULL, &_tmp163_);
			_tmp164_ = _tmp163_;
			_g_free0 (_tmp162_);
			response = _tmp164_;
			_tmp165_ = json_builder_new ();
			builder = _tmp165_;
			_tmp166_ = builder;
			server_response_append (&response, _tmp166_, NULL);
			_tmp167_ = generator;
			_tmp168_ = builder;
			_tmp169_ = json_builder_get_root (_tmp168_);
			_tmp170_ = _tmp169_;
			json_generator_set_root (_tmp167_, _tmp170_);
			__vala_JsonNode_free0 (_tmp170_);
			_tmp171_ = stdout;
			_tmp172_ = generator;
			_tmp174_ = json_generator_to_data (_tmp172_, &_tmp173_);
			length = _tmp173_;
			_tmp175_ = _tmp174_;
			fprintf (_tmp171_, "%s\n", _tmp175_);
			_g_free0 (_tmp175_);
			_g_object_unref0 (builder);
			server_response_destroy (&response);
			_g_free0 (method);
			_g_free0 (jsonrpc);
			__vala_JsonObject_free0 (object);
			__vala_JsonNode_free0 (root);
			continue;
		}
		params = NULL;
		_tmp176_ = object;
		_tmp177_ = json_object_has_member (_tmp176_, "params");
		if (_tmp177_) {
			JsonObject* _tmp178_;
			JsonNode* _tmp179_ = NULL;
			JsonNode* _tmp180_;
			_tmp178_ = object;
			_tmp179_ = json_object_get_member (_tmp178_, "params");
			_tmp180_ = __vala_JsonNode_copy0 (_tmp179_);
			__vala_JsonNode_free0 (params);
			params = _tmp180_;
		}
		id = NULL;
		_tmp181_ = object;
		_tmp182_ = json_object_has_member (_tmp181_, "id");
		if (_tmp182_) {
			JsonObject* _tmp183_;
			JsonNode* _tmp184_ = NULL;
			JsonNode* _tmp185_;
			_tmp183_ = object;
			_tmp184_ = json_object_get_member (_tmp183_, "id");
			_tmp185_ = __vala_JsonNode_copy0 (_tmp184_);
			__vala_JsonNode_free0 (id);
			id = _tmp185_;
		}
		_tmp186_ = self->priv->command_handlers;
		_tmp187_ = method;
		_tmp188_ = gee_map_get (_tmp186_, _tmp187_);
		handler = (CommandHandler*) _tmp188_;
		_tmp189_ = handler;
		_tmp190_ = params;
		command_handler_call (_tmp189_, _tmp190_, &_tmp191_);
		response = _tmp191_;
		_tmp192_ = json_builder_new ();
		builder = _tmp192_;
		_tmp193_ = builder;
		_tmp194_ = id;
		server_response_append (&response, _tmp193_, _tmp194_);
		_tmp195_ = generator;
		_tmp196_ = builder;
		_tmp197_ = json_builder_get_root (_tmp196_);
		_tmp198_ = _tmp197_;
		json_generator_set_root (_tmp195_, _tmp198_);
		__vala_JsonNode_free0 (_tmp198_);
		_tmp199_ = stdout;
		_tmp200_ = generator;
		_tmp202_ = json_generator_to_data (_tmp200_, &_tmp201_);
		length = _tmp201_;
		_tmp203_ = _tmp202_;
		fprintf (_tmp199_, "%s\n", _tmp203_);
		_g_free0 (_tmp203_);
		_tmp204_ = g_main_context_default ();
		g_main_context_iteration (_tmp204_, FALSE);
		_g_object_unref0 (builder);
		server_response_destroy (&response);
		_g_object_unref0 (handler);
		__vala_JsonNode_free0 (id);
		__vala_JsonNode_free0 (params);
		_g_free0 (method);
		_g_free0 (jsonrpc);
		__vala_JsonObject_free0 (object);
		__vala_JsonNode_free0 (root);
	}
	result = TRUE;
	_g_object_unref0 (parser);
	_g_object_unref0 (generator);
	_g_free0 (line);
	_g_object_unref0 (model);
	return result;
}


static void server_repl_create_error_response (ServerRepl* self, ServerErrorCode code, const gchar* message, JsonNode* data, ServerResponse* result) {
	ServerError _error_ = {0};
	ServerErrorCode _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	ServerError _tmp3_ = {0};
	ServerResponse response = {0};
	ServerError _tmp4_;
	ServerError _tmp5_;
	ServerError* _tmp6_;
	ServerResponse _tmp7_ = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (message != NULL);
	_tmp0_ = code;
	_tmp1_ = message;
	_tmp2_ = g_strdup (_tmp1_);
	memset (&_tmp3_, 0, sizeof (ServerError));
	_tmp3_.code = _tmp0_;
	_g_free0 (_tmp3_.message);
	_tmp3_.message = _tmp2_;
	__vala_JsonNode_free0 (_tmp3_.data);
	_tmp3_.data = NULL;
	_error_ = _tmp3_;
	_tmp4_ = _error_;
	_tmp5_ = _tmp4_;
	_tmp6_ = _server_error_dup0 (&_tmp5_);
	memset (&_tmp7_, 0, sizeof (ServerResponse));
	__vala_JsonNode_free0 (_tmp7_.result);
	_tmp7_.result = NULL;
	_server_error_free0 (_tmp7_.error);
	_tmp7_.error = _tmp6_;
	response = _tmp7_;
	*result = response;
	server_error_destroy (&_error_);
	return;
}


static JsonArray* _vala_JsonArray_copy (JsonArray* self) {
	return g_boxed_copy (json_array_get_type (), self);
}


static gpointer __vala_JsonArray_copy0 (gpointer self) {
	return self ? _vala_JsonArray_copy (self) : NULL;
}


static void _vala_JsonArray_free (JsonArray* self) {
	g_boxed_free (json_array_get_type (), self);
}


static void server_repl_do_process_key_events (ServerRepl* self, JsonNode* params, ServerResponse* result) {
	gboolean _tmp0_ = FALSE;
	JsonNode* _tmp1_;
	gboolean _tmp4_;
	gboolean retval = FALSE;
	JsonArray* array = NULL;
	JsonNode* _tmp6_;
	JsonArray* _tmp7_ = NULL;
	JsonArray* _tmp8_;
	JsonNode* node = NULL;
	JsonNode* _tmp25_;
	JsonNode* _tmp26_;
	gboolean _tmp27_;
	ServerResponse response = {0};
	JsonNode* _tmp28_;
	JsonNode* _tmp29_;
	ServerResponse _tmp30_ = {0};
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp1_ = params;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		JsonNode* _tmp2_;
		JsonNodeType _tmp3_ = 0;
		_tmp2_ = params;
		_tmp3_ = json_node_get_node_type (_tmp2_);
		_tmp0_ = _tmp3_ != JSON_NODE_ARRAY;
	}
	_tmp4_ = _tmp0_;
	if (_tmp4_) {
		ServerResponse _tmp5_ = {0};
		server_repl_create_error_response (self, SERVER_ERROR_CODE_INVALID_PARAMS, "params should be array", NULL, &_tmp5_);
		*result = _tmp5_;
		return;
	}
	retval = FALSE;
	_tmp6_ = params;
	_tmp7_ = json_node_get_array (_tmp6_);
	_tmp8_ = __vala_JsonArray_copy0 (_tmp7_);
	array = _tmp8_;
	{
		gint index = 0;
		index = 0;
		{
			gboolean _tmp9_ = FALSE;
			_tmp9_ = TRUE;
			while (TRUE) {
				gboolean _tmp10_;
				gint _tmp12_;
				JsonArray* _tmp13_;
				guint _tmp14_ = 0U;
				gchar* str = NULL;
				JsonArray* _tmp15_;
				gint _tmp16_;
				const gchar* _tmp17_ = NULL;
				gchar* _tmp18_;
				KkcKeyEvent* key = NULL;
				KkcContext* _tmp22_;
				KkcKeyEvent* _tmp23_;
				gboolean _tmp24_ = FALSE;
				_tmp10_ = _tmp9_;
				if (!_tmp10_) {
					gint _tmp11_;
					_tmp11_ = index;
					index = _tmp11_ + 1;
				}
				_tmp9_ = FALSE;
				_tmp12_ = index;
				_tmp13_ = array;
				_tmp14_ = json_array_get_length (_tmp13_);
				if (!(((guint) _tmp12_) < _tmp14_)) {
					break;
				}
				_tmp15_ = array;
				_tmp16_ = index;
				_tmp17_ = json_array_get_string_element (_tmp15_, (guint) _tmp16_);
				_tmp18_ = g_strdup (_tmp17_);
				str = _tmp18_;
				{
					KkcKeyEvent* _tmp19_ = NULL;
					const gchar* _tmp20_;
					KkcKeyEvent* _tmp21_;
					_tmp20_ = str;
					_tmp21_ = kkc_key_event_new_from_string (_tmp20_, &_inner_error_);
					_tmp19_ = _tmp21_;
					if (_inner_error_ != NULL) {
						if (_inner_error_->domain == KKC_KEY_EVENT_FORMAT_ERROR) {
							goto __catch14_kkc_key_event_format_error;
						}
						_g_object_unref0 (key);
						_g_free0 (str);
						__vala_JsonArray_free0 (array);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
					_g_object_unref0 (key);
					key = _tmp19_;
				}
				goto __finally14;
				__catch14_kkc_key_event_format_error:
				{
					GError* e = NULL;
					e = _inner_error_;
					_inner_error_ = NULL;
					_g_error_free0 (e);
					_g_object_unref0 (key);
					_g_free0 (str);
					break;
				}
				__finally14:
				if (_inner_error_ != NULL) {
					_g_object_unref0 (key);
					_g_free0 (str);
					__vala_JsonArray_free0 (array);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
				_tmp22_ = self->priv->context;
				_tmp23_ = key;
				_tmp24_ = kkc_context_process_key_event (_tmp22_, _tmp23_);
				if (_tmp24_) {
					retval = TRUE;
				}
				_g_object_unref0 (key);
				_g_free0 (str);
			}
		}
	}
	_tmp25_ = json_node_new (JSON_NODE_VALUE);
	node = _tmp25_;
	_tmp26_ = node;
	_tmp27_ = retval;
	json_node_set_boolean (_tmp26_, _tmp27_);
	_tmp28_ = node;
	_tmp29_ = __vala_JsonNode_copy0 (_tmp28_);
	memset (&_tmp30_, 0, sizeof (ServerResponse));
	__vala_JsonNode_free0 (_tmp30_.result);
	_tmp30_.result = _tmp29_;
	_server_error_free0 (_tmp30_.error);
	_tmp30_.error = NULL;
	response = _tmp30_;
	*result = response;
	__vala_JsonNode_free0 (node);
	__vala_JsonArray_free0 (array);
	return;
}


static void server_repl_do_poll_output (ServerRepl* self, JsonNode* params, ServerResponse* result) {
	gchar* output = NULL;
	KkcContext* _tmp0_;
	gchar* _tmp1_ = NULL;
	JsonNode* node = NULL;
	JsonNode* _tmp2_;
	ServerResponse response = {0};
	JsonNode* _tmp3_;
	ServerResponse _tmp4_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->context;
	_tmp1_ = kkc_context_poll_output (_tmp0_);
	output = _tmp1_;
	_tmp2_ = json_node_new (JSON_NODE_VALUE);
	node = _tmp2_;
	json_node_set_string (node, output);
	_tmp3_ = __vala_JsonNode_copy0 (node);
	memset (&_tmp4_, 0, sizeof (ServerResponse));
	__vala_JsonNode_free0 (_tmp4_.result);
	_tmp4_.result = _tmp3_;
	_server_error_free0 (_tmp4_.error);
	_tmp4_.error = NULL;
	response = _tmp4_;
	*result = response;
	__vala_JsonNode_free0 (node);
	_g_free0 (output);
	return;
}


static void server_repl_do_get_segments (ServerRepl* self, JsonNode* params, ServerResponse* result) {
	JsonArray* array = NULL;
	JsonArray* _tmp0_;
	JsonNode* node = NULL;
	JsonNode* _tmp26_;
	JsonArray* _tmp27_;
	ServerResponse response = {0};
	JsonNode* _tmp28_;
	ServerResponse _tmp29_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = json_array_new ();
	array = _tmp0_;
	{
		KkcSegmentList* _segment_list = NULL;
		KkcContext* _tmp1_;
		KkcSegmentList* _tmp2_;
		KkcSegmentList* _tmp3_;
		KkcSegmentList* _tmp4_;
		gint _segment_size = 0;
		KkcSegmentList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _segment_index = 0;
		_tmp1_ = self->priv->context;
		_tmp2_ = kkc_context_get_segments (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = _g_object_ref0 (_tmp3_);
		_segment_list = _tmp4_;
		_tmp5_ = _segment_list;
		_tmp6_ = kkc_segment_list_get_size (_tmp5_);
		_tmp7_ = _tmp6_;
		_segment_size = _tmp7_;
		_segment_index = -1;
		while (TRUE) {
			gint _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
			KkcSegment* segment = NULL;
			KkcSegmentList* _tmp11_;
			gint _tmp12_;
			KkcSegment* _tmp13_ = NULL;
			JsonObject* object = NULL;
			JsonObject* _tmp14_;
			JsonObject* _tmp15_;
			KkcSegment* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
			JsonObject* _tmp19_;
			KkcSegment* _tmp20_;
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			JsonArray* _tmp23_;
			JsonObject* _tmp24_;
			JsonObject* _tmp25_;
			_tmp8_ = _segment_index;
			_segment_index = _tmp8_ + 1;
			_tmp9_ = _segment_index;
			_tmp10_ = _segment_size;
			if (!(_tmp9_ < _tmp10_)) {
				break;
			}
			_tmp11_ = _segment_list;
			_tmp12_ = _segment_index;
			_tmp13_ = kkc_segment_list_get (_tmp11_, _tmp12_);
			segment = _tmp13_;
			_tmp14_ = json_object_new ();
			object = _tmp14_;
			_tmp15_ = object;
			_tmp16_ = segment;
			_tmp17_ = kkc_segment_get_input (_tmp16_);
			_tmp18_ = _tmp17_;
			json_object_set_string_member (_tmp15_, "input", _tmp18_);
			_tmp19_ = object;
			_tmp20_ = segment;
			_tmp21_ = kkc_segment_get_output (_tmp20_);
			_tmp22_ = _tmp21_;
			json_object_set_string_member (_tmp19_, "output", _tmp22_);
			_tmp23_ = array;
			_tmp24_ = object;
			_tmp25_ = __vala_JsonObject_copy0 (_tmp24_);
			json_array_add_object_element (_tmp23_, _tmp25_);
			__vala_JsonObject_free0 (object);
			_g_object_unref0 (segment);
		}
		_g_object_unref0 (_segment_list);
	}
	_tmp26_ = json_node_new (JSON_NODE_ARRAY);
	node = _tmp26_;
	_tmp27_ = array;
	json_node_set_array (node, _tmp27_);
	_tmp28_ = __vala_JsonNode_copy0 (node);
	memset (&_tmp29_, 0, sizeof (ServerResponse));
	__vala_JsonNode_free0 (_tmp29_.result);
	_tmp29_.result = _tmp28_;
	_server_error_free0 (_tmp29_.error);
	_tmp29_.error = NULL;
	response = _tmp29_;
	*result = response;
	__vala_JsonNode_free0 (node);
	__vala_JsonArray_free0 (array);
	return;
}


static void server_repl_do_get_input (ServerRepl* self, JsonNode* params, ServerResponse* result) {
	JsonNode* node = NULL;
	JsonNode* _tmp0_;
	KkcContext* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	ServerResponse response = {0};
	JsonNode* _tmp5_;
	ServerResponse _tmp6_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = json_node_new (JSON_NODE_VALUE);
	node = _tmp0_;
	_tmp1_ = self->priv->context;
	_tmp2_ = kkc_context_get_input (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_;
	json_node_set_string (node, _tmp4_);
	_g_free0 (_tmp4_);
	_tmp5_ = __vala_JsonNode_copy0 (node);
	memset (&_tmp6_, 0, sizeof (ServerResponse));
	__vala_JsonNode_free0 (_tmp6_.result);
	_tmp6_.result = _tmp5_;
	_server_error_free0 (_tmp6_.error);
	_tmp6_.error = NULL;
	response = _tmp6_;
	*result = response;
	__vala_JsonNode_free0 (node);
	return;
}


static void server_repl_do_reset (ServerRepl* self, JsonNode* params, ServerResponse* result) {
	KkcContext* _tmp0_;
	JsonNode* node = NULL;
	JsonNode* _tmp1_;
	ServerResponse response = {0};
	JsonNode* _tmp2_;
	ServerResponse _tmp3_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->context;
	kkc_context_reset (_tmp0_);
	_tmp1_ = json_node_new (JSON_NODE_NULL);
	node = _tmp1_;
	_tmp2_ = __vala_JsonNode_copy0 (node);
	memset (&_tmp3_, 0, sizeof (ServerResponse));
	__vala_JsonNode_free0 (_tmp3_.result);
	_tmp3_.result = _tmp2_;
	_server_error_free0 (_tmp3_.error);
	_tmp3_.error = NULL;
	response = _tmp3_;
	*result = response;
	__vala_JsonNode_free0 (node);
	return;
}


ServerRepl* server_repl_construct (GType object_type) {
	ServerRepl * self = NULL;
	self = (ServerRepl*) g_object_new (object_type, NULL);
	return self;
}


ServerRepl* server_repl_new (void) {
	return server_repl_construct (TYPE_SERVER_REPL);
}


static void _server_repl_do_process_key_events_command_callback (JsonNode* params, ServerResponse* result, gpointer self) {
	server_repl_do_process_key_events (self, params, result);
}


static void _server_repl_do_poll_output_command_callback (JsonNode* params, ServerResponse* result, gpointer self) {
	server_repl_do_poll_output (self, params, result);
}


static void _server_repl_do_get_segments_command_callback (JsonNode* params, ServerResponse* result, gpointer self) {
	server_repl_do_get_segments (self, params, result);
}


static void _server_repl_do_get_input_command_callback (JsonNode* params, ServerResponse* result, gpointer self) {
	server_repl_do_get_input (self, params, result);
}


static void _server_repl_do_reset_command_callback (JsonNode* params, ServerResponse* result, gpointer self) {
	server_repl_do_reset (self, params, result);
}


static GObject * server_repl_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	ServerRepl * self;
	GeeHashMap* _tmp0_;
	GeeMap* _tmp1_;
	CommandHandler* _tmp2_;
	CommandHandler* _tmp3_;
	GeeMap* _tmp4_;
	CommandHandler* _tmp5_;
	CommandHandler* _tmp6_;
	GeeMap* _tmp7_;
	CommandHandler* _tmp8_;
	CommandHandler* _tmp9_;
	GeeMap* _tmp10_;
	CommandHandler* _tmp11_;
	CommandHandler* _tmp12_;
	GeeMap* _tmp13_;
	CommandHandler* _tmp14_;
	CommandHandler* _tmp15_;
	parent_class = G_OBJECT_CLASS (server_repl_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SERVER_REPL, ServerRepl);
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, TYPE_COMMAND_HANDLER, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->command_handlers);
	self->priv->command_handlers = (GeeMap*) _tmp0_;
	_tmp1_ = self->priv->command_handlers;
	_tmp2_ = command_handler_new (_server_repl_do_process_key_events_command_callback, self);
	_tmp3_ = _tmp2_;
	gee_map_set (_tmp1_, "processKeyEvents", _tmp3_);
	_g_object_unref0 (_tmp3_);
	_tmp4_ = self->priv->command_handlers;
	_tmp5_ = command_handler_new (_server_repl_do_poll_output_command_callback, self);
	_tmp6_ = _tmp5_;
	gee_map_set (_tmp4_, "pollOutput", _tmp6_);
	_g_object_unref0 (_tmp6_);
	_tmp7_ = self->priv->command_handlers;
	_tmp8_ = command_handler_new (_server_repl_do_get_segments_command_callback, self);
	_tmp9_ = _tmp8_;
	gee_map_set (_tmp7_, "getSegments", _tmp9_);
	_g_object_unref0 (_tmp9_);
	_tmp10_ = self->priv->command_handlers;
	_tmp11_ = command_handler_new (_server_repl_do_get_input_command_callback, self);
	_tmp12_ = _tmp11_;
	gee_map_set (_tmp10_, "getInput", _tmp12_);
	_g_object_unref0 (_tmp12_);
	_tmp13_ = self->priv->command_handlers;
	_tmp14_ = command_handler_new (_server_repl_do_reset_command_callback, self);
	_tmp15_ = _tmp14_;
	gee_map_set (_tmp13_, "reset", _tmp15_);
	_g_object_unref0 (_tmp15_);
	return obj;
}


static void server_repl_class_init (ServerReplClass * klass) {
	server_repl_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ServerReplPrivate));
	G_OBJECT_CLASS (klass)->constructor = server_repl_constructor;
	G_OBJECT_CLASS (klass)->finalize = server_repl_finalize;
}


static void server_repl_repl_interface_init (ReplIface * iface) {
	server_repl_repl_parent_iface = g_type_interface_peek_parent (iface);
	iface->parse_arguments = (gboolean (*)(Repl*, gchar**, int, GError**)) server_repl_real_parse_arguments;
	iface->run = (gboolean (*)(Repl*, GError**)) server_repl_real_run;
}


static void server_repl_instance_init (ServerRepl * self) {
	self->priv = SERVER_REPL_GET_PRIVATE (self);
}


static void server_repl_finalize (GObject* obj) {
	ServerRepl * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SERVER_REPL, ServerRepl);
	_g_object_unref0 (self->priv->context);
	_g_object_unref0 (self->priv->command_handlers);
	G_OBJECT_CLASS (server_repl_parent_class)->finalize (obj);
}


GType server_repl_get_type (void) {
	static volatile gsize server_repl_type_id__volatile = 0;
	if (g_once_init_enter (&server_repl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ServerReplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) server_repl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ServerRepl), 0, (GInstanceInitFunc) server_repl_instance_init, NULL };
		static const GInterfaceInfo repl_info = { (GInterfaceInitFunc) server_repl_repl_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType server_repl_type_id;
		server_repl_type_id = g_type_register_static (G_TYPE_OBJECT, "ServerRepl", &g_define_type_info, 0);
		g_type_add_interface_static (server_repl_type_id, TYPE_REPL, &repl_info);
		g_once_init_leave (&server_repl_type_id__volatile, server_repl_type_id);
	}
	return server_repl_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



